diff --git a/typing/debug_message.ml b/typing/debug_message.ml
new file mode 100644
index 0000000..f9a6c81
--- /dev/null
+++ b/typing/debug_message.ml
@@ -0,0 +1,1081 @@
+open Format
+open Printtyp
+open Parsetree
+open Syntaxerr (* for language_t, language *)
+
+let ppf = std_formatter
+
+let nth n = match n with
+    1 -> "1st"
+  | 2 -> "2nd"
+  | 3 -> "3rd"
+  | _ -> string_of_int n ^ "th"
+
+let print_loc loc =
+  Location.print_loc ppf loc;
+  fprintf ppf ":@."
+
+let rec string_of_longident t = match t with
+    Longident.Lident (l) -> l
+  | Longident.Ldot (t, l) -> (string_of_longident t) ^ "." ^ l
+  | _ -> assert false;;
+
+let print_initial_message () =
+  match language with
+| English -> fprintf ppf
+    "@[The above type error was raised.  Type debugger started.@]@.@."
+| Japanese -> fprintf ppf
+    "@[上記の型エラーが起こりました。デバッガを起動します。@]@.@."
+
+let print_prompt () =
+  fprintf ppf "@[(y/n/q) > @]@?"
+
+let print_ask_env st typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[In this scope, do you intend '%s' to be of type:@ %a ?@]@."
+    st Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[ハイライトされた部分のスコープで %s を@ %a@ 型だと意図していますか？@]@."
+    st Printtyp.type_expr typ
+
+let print_ask_expr typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[Do you intend this expression to be of type:@ %a ?@]@."
+    Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[ハイライトされた部分の型を@ %a@ だと意図していますか？@]@."
+    Printtyp.type_expr typ
+
+let print_identified () =
+  match language with
+| English -> fprintf ppf
+    "@[The source of the type error is highlighted.@]@."
+| Japanese -> fprintf ppf
+    "@[ハイライトされた部分に特定されました。@]@."
+
+let check_duplicate typ1 typ2 =
+  (* type_expr を Ident.t list にする *)
+  (* idents_of_typexp : type_expr -> Ident.t list *)
+  let rec idents_of_typexp {Types.desc = desc} =
+    match desc with
+      Types.Tconstr (path, tyl, _) ->
+       let rec get_id p = match p with
+           Path.Pident (id) -> [id] (* path の情報がある *)
+         | Path.Pdot (p, _) -> get_id p
+         | Path.Papply (p1, p2) -> (get_id p1) @ (get_id p2) in
+       List.fold_left (fun il ty -> il @ idents_of_typexp ty) (get_id path) tyl
+    | Types.Tlink (ty) -> idents_of_typexp ty
+    | Types.Tsubst (ty) -> idents_of_typexp ty
+    | Types.Tarrow (_, ty1, ty2, _) ->
+       (idents_of_typexp ty1) @ (idents_of_typexp ty2)
+    | Types.Ttuple (tyl) ->
+       List.fold_left (fun il ty -> il @ idents_of_typexp ty) [] tyl
+    | Types.Tvar _ | Types.Tobject _
+    | Types.Tfield _ | Types.Tnil | Types.Tvariant _ | Types.Tunivar _
+    | Types.Tpoly _ | Types.Tpackage _ -> [] in
+  let is_duplicate i1 i2 =
+    (* equal = true,  same = true  : 同一の型 *)
+    (* equal = true,  same = false : 同じ名前だが別の型 *)
+    (* equal = false, same = false : 全く異なる型 *)
+    if (Ident.equal i1 i2) <> (Ident.same i1 i2) then
+      fprintf ppf "@[（%s が二重に定義されています。）@]@." (Ident.name i1) in
+  let print_duplicate typ1 typ2 =
+    let idl1 = idents_of_typexp typ1 in
+    let idl2 = idents_of_typexp typ2 in
+    try List.iter2 is_duplicate idl1 idl2 with
+      Invalid_argument _ -> () in
+  print_duplicate typ1 typ2
+
+(*** print error massage ***)
+(*
+
+特定される構文ごとに分類
+・式
+<Pexp_ifthenelse>
+  Error12 -- Error15
+<Pexp_apply>
+  Error17 -- Error19, Error27 -- Error28
+<Pexp_function><Pexp_fun>
+  Error20
+<Pexp_match>
+  Error21 -- Error24, Error33
+<Pexp_try>
+  Error53 -- Error55
+<Pexp_construct>
+  Error25, Error56, print_duplicate_name (共通)
+<Pexp_record>
+  Error34 -- Error35, Error51 -- Error52, Error56, print_duplicate_name (共通)
+
+<Pexp_constraint>
+  Error36
+
+<Pexp_array>
+  Error38
+・パターン変数
+Error30
+Error39
+Error40
+
+  print_recursive as
+  Error1  : 再帰関数の定義と呼び出しで型が合わない
+  print_patexps as
+  Error2  : パターンと式の型が合わない
+  (print_patexps2 as Error3)
+  print_welltyped_expr as
+  Error4  : 式の型がプログラマの意図と異なる
+  print_welltyped_env1 as
+  Error5  : 環境の変数のうち一つが別の型として使われている
+  print_welltyped_env_many as
+  Error6  : 環境の変数のうち複数が別の型として使われている
+  (print_welltyped_if_bool as Error7)
+  (print_welltyped_if_unit as Error8)
+  (print_welltyped_if_then_else as Error9)
+  (print_welltyped_match_pattern as Error10)
+  (print_welltyped_match_expression as Error11)
+  print_illtyped_if_predicate as
+  Error12 : 条件部分が bool 型でない
+  print_illtyped_if_then as
+  Error13 : else 部分がない
+  print_illtyped_if_fv as
+  Error14 : if 文の中で同じ変数が別の型として扱われている
+  print_illtyped_if_then_else as
+  Error15 : then 部分と else 部分で型が異なる
+  (print_illtyped_apply as Error16)
+  print_illtyped_apply_funname as
+  Error17 : 関数呼び出しの引数の型が合わない
+  (print_illtyped_apply_beginning as Error18)
+  (print_illtyped_apply_beginning2 as Error19)
+  print_illtyped_function as
+  Error20 : function 文の型エラー
+  print_illtyped_match_exp as
+  Error21 : パターンと match する式の型が異なる
+  print_illtyped_match_left as
+  Error22 : match 文のパターンに複数の型が混在している
+  print_illtyped_match_right as
+  Error23 : match 文の結果に複数の型が混在している
+  (print_illtyped_match_fv as Error24)
+  print_illtyped_constructor as
+  Error25 : コンストラクタのエラー
+  print_illtyped_other as
+  Error26 : デフォルトケース
+  print_illtyped_too_much_args as
+  Error27 : 関数に渡す引数が多い
+  print_illtyped_apply_not_function as
+  Error28 : 関数部分が関数でない
+  print_illtyped_var_undefined as
+  Error29 : 変数が未定義、もしくはstructure_item における区切りがない
+  print_pattern as
+  Error30 : パターンのエラー
+  print_guard as
+  Error32 : ガードのエラー
+  (print_guard_env as Error33)
+  print_illtyped_match_right2 as
+  Error33 : match 文の中で同じ変数が別の型として扱われている
+  print_illtyped_record as
+  Error34 : レコード内の要素の型が定義と異なる
+  print_label_mul as
+  Error35 : レコード内であるフィールドが複数回現れている
+  print_illtyped_constraint as
+  Error36 : (expr : core_type) の左右で型が一致しない
+  print_no_method_use as
+  Error37 : #use の前に区切りがない
+  print_illtyped_array as
+  Error38 : 配列のエラー
+
+  Error41 : let文のエラー(nonrec)
+  Error42 : let文のエラー(rec 1)
+  Error43 : let文のエラー(rec many)
+
+  print_label_mismatch as
+  Error51 : 複数のレコードに定義されたフィールドが混在している
+  print_label_missing as
+  Error52 : 使われていないフィールドがある
+  print_illtyped_try_right as
+  Error53 : try 文の結果に複数の型が混在している
+  print_illtyped_try_left as
+  Error54 : try 文のパターンに複数の型が混在している
+  print_illtyped_try_env as
+  Error55 : try 文の中で同じ変数が別の型として扱われている
+  print_wrong_name as
+  Error56 : 未定義のコンストラクタ/フィールドが存在する
+
+↓並べ替えるなら↓
+・デフォルトケース
+・未定義
+・welltyped のやつ
+・関数適用
+・fun文、function文
+・if文
+・パターンマッチ
+・try文
+・パターン
+・ガード
+・再帰
+・コンストラクタ
+・コンストラクタ/レコード共通
+・レコード
+・#use、constraint、配列
+
+
+*)
+
+let print_recursive typ st typ' =
+  Printtyp.reset_and_mark_loops typ;
+  Printtyp.reset_and_mark_loops typ';
+  match language with
+| English -> fprintf ppf
+    "@[Error1 : The function %s has type@ %a,\
+     @ but '%s' is used at type@ %a in this recursive call.@]@."
+    st Printtyp.type_expr typ st Printtyp.type_expr typ'
+| Japanese -> fprintf ppf
+    "@[Error1 : 関数 %s は@ %a@ 型ですが、@,\
+     再帰呼び出しで %s を %a@ 型として使っています。@,\
+     （再帰呼び出し時の引数の数や型は合っていますか？）@]@."
+    st Printtyp.type_expr typ st Printtyp.type_expr typ'
+
+let print_patexps typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[Error2 : This expression has type:@ %a,\
+     @ but it conflicts with the type of the pattern.@]@."
+    Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[Error2 : この式は@ %a@ 型で、@,\
+     期待されるパターンの型と合いません。@]@."
+    Printtyp.type_expr typ
+
+let print_patexps2 () =
+ (* Printtyp.reset_and_mark_loops pattyp;*)
+  match language with
+| English -> fprintf ppf
+    "@[Error3 : This expression has constant type,@,\
+     but it conflicts with the type of the pattern.@]@."
+| Japanese -> fprintf ppf
+    "@[Error3 : この式は定数になっていますが、@,\
+     let 文で束縛する式は変数もしくはパターンでなければなりません。@]@."
+
+let print_welltyped_expr typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[Error4 : This expression has type@ %a.@]@."
+    Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[Error4 : この式の型は@ %a@ 型です。@]@."
+    Printtyp.type_expr typ
+
+let print_welltyped_env1 st typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[Error5 : The variable '%s' is used as an expression of type:@ %a.@]@."
+    st Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[Error5 : 変数 %s は@ %a@ 型として使われています。@]@."
+    st Printtyp.type_expr typ
+
+let print_welltyped_env_many st typ rest =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "@[Error6 : Following variables are used as expressions of types:@]@."
+| Japanese -> fprintf ppf
+    "@[Error6 : 次の変数は示される型として使われています。@]@."
+  end;
+  fprintf ppf "  @[%s : %a" st Printtyp.type_expr typ;
+  List.iter (fun (((st, _), _, _), typ) ->
+              (* Printtyp.reset_and_mark_loops typ; *)
+              fprintf ppf ",@ %s : %a" st Printtyp.type_expr typ)
+            rest;
+  fprintf ppf "@]@."
+
+let print_welltyped_if_bool st typ rest =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "Error7 : Expressions at the following variables need the following types.\
+     @. The predicate of a conditional expression needs to have type bool.@."
+| Japanese -> fprintf ppf
+    "Error7 : 次の変数が示される型になっています。@,\
+     if 文の条件部は bool 型でなければなりません。@."
+  end;
+  fprintf ppf "  @[%s : %a" st Printtyp.type_expr typ;
+  List.iter (fun (((st, _), _, _), typ) ->
+              (* Printtyp.reset_and_mark_loops typ; *)
+              fprintf ppf ",@ %s : %a" st Printtyp.type_expr typ)
+            rest;
+  fprintf ppf "@]@."
+
+let print_welltyped_if_unit st typ rest =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "Error8 : Expressions at the following variables need the following types.\
+     @. Since the conditional expression does not have else branch,@,\
+     then branch needs to have type unit.@. (or you might forgot else branch)@."
+| Japanese -> fprintf ppf
+    "Error8 : 次の変数が示される型になっています。@,\
+     else 部分がないため if 文の then 部分は unit 型でなければなりません。@,\
+     （もしくは else 部分を忘れていませんか？）@."
+  end;
+  fprintf ppf "  @[%s : %a" st Printtyp.type_expr typ;
+  List.iter (fun (((st, _), _, _), typ) ->
+              (* Printtyp.reset_and_mark_loops typ; *)
+              fprintf ppf ",@ %s : %a" st Printtyp.type_expr typ)
+            rest;
+  fprintf ppf "@]@."
+
+let print_welltyped_if_then_else st typ rest =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "Error9 : Expressions at the following variables need the following types.\
+     @. Then branch and else branch of a conditional expression need to be \
+     the same type.@."
+| Japanese -> fprintf ppf
+    "Error9 : 次の変数が示される型になっています。@,\
+     if 文の then 部分と else 部分は同じ型でなければなりません。@."
+  end;
+  fprintf ppf "  @[%s : %a" st Printtyp.type_expr typ;
+  List.iter (fun (((st, _), _, _), typ) ->
+              (* Printtyp.reset_and_mark_loops typ; *)
+              fprintf ppf ",@ %s : %a" st Printtyp.type_expr typ)
+            rest;
+  fprintf ppf "@]@."
+
+(* TODO : English messages *)
+let print_welltyped_match_pattern st typ rest =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "Error10 : Expressions at the following variables need the following types:\
+     @."
+| Japanese -> fprintf ppf
+    "Error10 : 次の変数が示される型になっています。@,\
+     match 文の矢印の左側は同じ型でなければなりません。@."
+  end;
+  fprintf ppf "  @[%s : %a" st Printtyp.type_expr typ;
+  List.iter (fun (((st, _), _, _), typ) ->
+              (* Printtyp.reset_and_mark_loops typ; *)
+              fprintf ppf ",@ %s : %a" st Printtyp.type_expr typ)
+            rest;
+  fprintf ppf "@]@."
+
+let print_welltyped_match_expression st typ rest =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "Error11 : Expressions at the following variables need the following types:\
+     @."
+| Japanese -> fprintf ppf
+    "Error11 : 次の変数が示される型になっています。@,\
+     match 文の矢印の右側は同じ型でなければなりません。@."
+  end;
+  fprintf ppf "  @[%s : %a" st Printtyp.type_expr typ;
+  List.iter (fun (((st, _), _, _), typ) ->
+              (* Printtyp.reset_and_mark_loops typ; *)
+              fprintf ppf ",@ %s : %a" st Printtyp.type_expr typ)
+            rest;
+  fprintf ppf "@]@."
+
+let print_illtyped_var_undefined () =
+  match language with
+| English -> fprintf ppf
+    "@[Error29 : This variable is undefined.@]@."
+| Japanese -> fprintf ppf
+    "@[Error29 : この変数は未定義です。@]@."
+
+let print_illtyped_if_predicate typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[Error12 : The type of the predicate part is:@ %a,@,\
+     but it has to be bool.]@."
+    Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[Error12 : 条件部分の型は@ %a@ ですが bool 型でなくてはなりません。@]@."
+    Printtyp.type_expr typ
+
+let print_illtyped_if_then typ =
+  Printtyp.reset_and_mark_loops typ;
+  begin match language with
+| English -> fprintf ppf
+    "@[Error13 : The type of the then branch is:@ %a,@,\
+     but it has to be unit.]@."
+    Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[Error13 : then 部分が@ %a @ 型になっていますが@ \
+     else 部分がないため unit 型でなくてはなりません。@]@."
+    Printtyp.type_expr typ
+  end;
+  begin match language with
+| English -> fprintf ppf
+    "@[(Or, you forgot the else branch perhaps?)@]@."
+| Japanese -> fprintf ppf
+    "@[（もしくは else 部分を書き忘れていませんか？）@]@."
+  end
+
+let print_illtyped_if_fv () =
+  match language with
+| English -> fprintf ppf
+    "@[Error14 : Some variables are used at different types.@]@."
+| Japanese -> fprintf ppf
+    "@[Error14 : 同じ変数が別の場所で別の型として使われています。@]@."
+
+let print_illtyped_if_then_else typ2 typ3 =
+  Printtyp.reset_and_mark_loops typ2;
+  Printtyp.reset_and_mark_loops typ3;
+  begin match language with
+| English -> fprintf ppf
+    "@[Error15 : The types of the then and else branches are:@ %a@ and@ %a,@,\
+     but they have to be the same.@,\
+     (Or, some variables are used at different types.)@]@."
+    Printtyp.type_expr typ2 Printtyp.type_expr typ3
+| Japanese -> fprintf ppf
+    "@[Error15 : then 部分が@ %a@ 型で else 部分が@ %a@ 型になっていますが、@,\
+     これらは同じ型でなくてはなりません。@,\
+     （または同じ変数が別の場所で別の型として使われています。）@]@."
+    Printtyp.type_expr typ2 Printtyp.type_expr typ3
+  end;
+  check_duplicate typ2 typ3
+
+let rec print_illtyped_apply_args typs n = match typs with
+    [] -> ()
+  | typ :: rest ->
+      begin match language with
+      | English -> fprintf ppf
+          " @[<2>%s argument :@ %a@]@." (nth n) Printtyp.type_expr typ
+      | Japanese -> fprintf ppf
+          " @[<2>%d 番目の引数の型：@,%a@]@." n Printtyp.type_expr typ
+      end;
+      print_illtyped_apply_args rest (n + 1)
+
+(* 関数名なし *)
+let print_illtyped_apply n exp_typ typs well_typ =
+  match language with
+| English ->
+    fprintf ppf
+      "@[Error16 : The type conflict occurs at the %s argument.@,\
+       The types of function and arguments, required type of %s argument are:@]"
+      (nth n) (nth n);
+    fprintf ppf
+      "@[Function :@ %a@]@."
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1;
+    fprintf ppf
+      " @[Required type of %s argument :@ %a@.@]"
+      (nth n) Printtyp.type_expr well_typ
+| Japanese ->
+    fprintf ppf
+      "@[Error16 : この関数呼び出しの %d 番目の引数で型が合いません。@,\
+       関数、引数、%d 番目の引数に要求される型は以下の通りです。@]@."
+      n n;
+    fprintf ppf
+      "@[関数部分：@,%a@]@."
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1;
+    fprintf ppf
+      " @[%d 番目の引数に要求される型：@,%a@.@]"
+      n Printtyp.type_expr well_typ
+
+(* 関数名あり *)
+let print_illtyped_apply_funname n exp_typ exps typs well_typ name =
+  if 7 <= Array.length Sys.argv then
+    fprintf ppf
+      "@[Function %a :@ %a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+
+  match language with
+| English ->
+    fprintf ppf
+      "@[Error17 : The type conflict occurs at the %s argument.@,\
+       The types of function and %s argument, required type of %s argument are:@]"
+      (nth n) (nth n) (nth n);
+    fprintf ppf
+      "@[Function %a :@ %a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    fprintf ppf
+      " @[<2>%s argument :@ %a@]@."
+      (nth n) Printtyp.type_expr (List.nth typs (n - 1));
+    fprintf ppf
+      " @[Required type of %s argument :@ %a@.@]"
+      (nth n) Printtyp.type_expr well_typ
+| Japanese -> fprintf ppf
+    "@[Error17 : この関数呼び出しの %d 番目の引数で型が合いません。@,\
+     関数、%d 番目の引数、%d 番目の引数に要求される型は以下の通りです。@]@." n n n;
+    fprintf ppf
+      "@[関数部分 %a：@,%a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    fprintf ppf
+      " @[<2>%d 番目の引数 %a：@,%a@]@."
+      n Pprintast.expression (List.nth exps (n - 1)) Printtyp.type_expr (List.nth typs (n - 1));
+    fprintf ppf
+      " @[%d 番目の引数に要求される型：@,%a@.@]"
+      n Printtyp.type_expr well_typ;
+    check_duplicate (List.nth typs (n - 1)) well_typ
+
+(*
+let print_illtyped_apply_funname n exp_typ typs well_typ name =
+  match language with
+| English ->
+    fprintf ppf
+      "@[Error17 : The type conflict occurs at the %s argument.@,\
+       The types of function and arguments, required type of %s argument are:@]"
+      (nth n) (nth n);
+    fprintf ppf
+      "@[Function %a :@ %a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1;
+    fprintf ppf
+      " @[Required type of %s argument :@ %a@.@]"
+      (nth n) Printtyp.type_expr well_typ
+| Japanese -> fprintf ppf
+    "@[Error17 : この関数呼び出しの %d 番目の引数で型が合いません。@,\
+     関数、引数、%d 番目の引数に要求される型は以下の通りです。@]@." n n;
+    fprintf ppf
+      "@[関数部分 %a：@,%a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1;
+    fprintf ppf
+      " @[%d 番目の引数に要求される型：@,%a@.@]"
+      n Printtyp.type_expr well_typ;
+    check_duplicate (List.nth typs (n - 1)) well_typ
+    *)
+
+let rec print_funtypes n funtypes =
+  match language with
+| English ->
+    begin match funtypes with
+        [] -> fprintf ppf
+          "@[(some arguments might be missing.)@]@."
+      | (m, typ) :: rest ->
+          fprintf ppf
+            " @[Type of %s argument :@ %a@]@."
+            (nth m) Printtyp.type_expr typ;
+          print_funtypes n rest
+    end
+| Japanese ->
+    begin match funtypes with
+        [] -> fprintf ppf
+          "@[これらに引数を渡すのを忘れていませんか？@]@."
+      | (m, typ) :: rest ->
+          fprintf ppf
+            " @[%d 番目の引数の型：@,%a@]@."
+            m Printtyp.type_expr typ;
+          print_funtypes n rest
+    end
+
+let print_illtyped_apply_beginning n name exp_typ typs funtype_args =
+  match language with
+| English ->
+    fprintf ppf
+      "@[Error18 : The type conflict occurs at the %s argument.@]@."
+      (nth n);
+    fprintf ppf
+      "@[Function %a :@ %a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1;
+    fprintf ppf
+      "@[The following arguments have function type.@]@.";
+    print_funtypes n funtype_args
+| Japanese ->
+    fprintf ppf
+      "@[Error18 : この関数呼び出しの %d 番目の引数で型が合いません。@]@."
+      n;
+    fprintf ppf
+      "@[関数部分 %a の型：@,%a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1;
+    fprintf ppf "@[以下の引数が関数型になっています。@]@.";
+    print_funtypes n funtype_args
+
+(* 関数型になっている引数がないとき *)
+let print_illtyped_apply_beginning2 =
+  print_illtyped_apply_funname
+(*
+let print_illtyped_apply_beginning2 n name exp_typ n_typ =
+  match language with
+| English ->
+    fprintf ppf
+      "@[Error19 : The type conflict occurs at the %s argument.@]@."
+      (nth n);
+| Japanese ->
+    fprintf ppf
+      "@[Error19 : この関数呼び出しの %d 番目の引数で型が合いません。@]@."
+      n;
+    fprintf ppf
+      "@[関数部分 %a の型：@,%a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    fprintf ppf
+      " @[%d 番目の引数の型：@,%a@.@]@."
+      n Printtyp.type_expr n_typ
+ *)
+
+let print_illtyped_function () =
+  match language with
+  | English ->
+      fprintf ppf
+        "@[Error20 : The pattern forces some variable an unintended type.@]@."
+  | Japanese ->
+      fprintf ppf
+        "@[Error20 : パターンによって変数の型が意図しないものに\
+         強制されています。@]@."
+
+let print_illtyped_match () =
+  match language with
+| English -> fprintf ppf
+    "@[Somewhere in this match expression is wrong.@]@."
+| Japanese -> fprintf ppf
+    "@[この match 文のどこかがおかしいです。@]@."
+
+let print_illtyped_match_exp typ1 typ2 =
+  match language with
+  | English ->
+      fprintf ppf
+        "@[Error21 : Somewhere in this match expression is wrong.@]@." (* 英語 *)
+| Japanese ->
+    fprintf ppf
+      "@[Error21 : match する式が@ %a@ 型でパターンが@ %a@ 型になっていますが、\
+       @,これらは同じ型でなくてはなりません。@]@."
+      Printtyp.type_expr typ1 Printtyp.type_expr typ2;
+    check_duplicate typ1 typ2
+
+let print_illtyped_match_left typ1 typ2 =
+  match language with
+| English -> fprintf ppf
+    "@[Error22 : Somewhere in this match expression is wrong.@]@." (* 英語 *)
+| Japanese -> fprintf ppf
+    "@[Error22 : ハイライト部分が@ %a@ 型でそれ以前までの矢印の左側が\
+     @ %a@ 型になっていますが、@,これらは同じ型でなくてはなりません。@]@."
+    Printtyp.type_expr typ1 Printtyp.type_expr typ2;
+              check_duplicate typ1 typ2
+
+let print_illtyped_match_right typ1 typ2 =
+  match language with
+| English -> fprintf ppf
+    "@[Error23 : The type of this expression is:@ %a,@,\
+     but the type of the preceeding clause is:@ %a.@,\
+     They must be the same type.@]@."
+    Printtyp.type_expr typ1 Printtyp.type_expr typ2
+| Japanese -> fprintf ppf
+    "@[Error23 : ハイライト部分が@ %a@ 型でそれ以前までの矢印の右側が\
+     @ %a@ 型になっていますが、@,これらは同じ型でなくてはなりません。@]@."
+    Printtyp.type_expr typ1 Printtyp.type_expr typ2;
+              check_duplicate typ1 typ2
+
+let print_illtyped_match_right2 () =
+  match language with
+| English -> fprintf ppf
+    "@[Error33 : Some variables in this expression is used at different type@ \
+     at different place.@]@."
+| Japanese -> fprintf ppf
+    "@[Error33 : ハイライト部分の変数が\
+     別の場所で別の型として使われています。@]@."
+
+let print_illtyped_match_fv () =
+  match language with
+| English -> fprintf ppf
+    "@[Error24 : Some variables are used at different types.@]@."
+| Japanese -> fprintf ppf
+    "@[Error24 : 同じ変数が別の場所で別の型として使われています。@]@."
+
+let rec print_type lid plst args =
+    match plst with
+    | [] ->
+       begin
+         if Longident.last lid = "::"
+         then
+           begin
+             match args with
+             | [Some (e1, t1); Some (e2, t2)] -> print_list_clash e1 t1 e2 t2
+             | [_; Some (_, typ)] -> print_list_mismatch typ
+             | _ -> ()
+           end
+         else
+           begin
+             print_constructor_name "'a option" lid;
+             if Longident.last lid = "Some"
+             then print_no_args "Some"
+             else print_arity_mismatch (List.length args) 0
+           end
+       end
+    | (name, vs) :: rest ->
+       try
+         print_args lid (name, vs) args
+       with
+         Not_found -> print_type lid rest args
+
+and print_args lid (name, vlst) args =
+  match vlst with
+  | [] -> raise Not_found
+  | (value, cts) :: rest ->
+     let a_sum = List.length args and c_sum = List.length cts in
+     let rec num t = match t with
+         [] -> 0
+       | first :: rest ->
+          if first = None
+          then num rest
+          else a_sum - (List.length rest) in
+     let n = num args in
+     if value <> string_of_longident lid
+     then
+       (* コンストラクタ名が一致しない場合は次へ進む *)
+       print_args lid (name, rest) args
+     else
+       begin
+         (* 該当するコンストラクタ名を表示 *)
+         print_constructor_name name lid;
+         if a_sum = 0
+         then
+           (* 引数が見つからない *)
+           print_no_args (string_of_longident lid)
+         else
+           begin
+             if a_sum = c_sum
+             then
+               (* 引数の数が同じ *)
+               let (en, tn) = match (List.nth args (n - 1)) with
+                 | Some (e, t) -> (e, t)
+                 | _ -> assert false in
+               begin
+                 print_arg_type_clash n (en, tn) (List.nth cts (n - 1));
+                 print_constuctor_type lid cts
+               end
+             else
+               (* 引数の数が異なる *)
+               print_arity_mismatch a_sum c_sum
+           end
+       end
+
+and print_list_clash e1 t1 e2 t2 =
+
+
+  fprintf ppf
+          "@[ハイライト部分のリストで、先頭の要素と末尾のリストの型が合いません。@ \
+           先頭の要素、末尾のリストは以下の通りです。@]@.";
+  fprintf ppf
+          " @[　先頭の要素 %a：@,%a @]@."
+          Pprintast.expression e1 Printtyp.type_expr t1;
+  fprintf ppf
+          " @[末尾のリスト %a：@,%a @]@."
+          Pprintast.expression e2 Printtyp.type_expr t2
+
+and print_list_mismatch typ =
+  fprintf ppf
+          "@[ハイライト部分の末尾が %a 型になっていますが、@ \
+           :: の右側はリストでなければなりません。@]@."
+          Printtyp.type_expr typ
+and print_constructor_name tname lid =
+  match lid with
+  | Longident.Ldot (t, l) ->
+     fprintf ppf
+             "@[ハイライトされた部分では、モジュール %s の中に定義された %s 型のコンストラクタ %s の、" (string_of_longident t) tname l
+  | _ ->
+     fprintf ppf
+             "@[%s 型のコンストラクタ %s の" tname (string_of_longident lid)
+
+and print_arg_type_clash n (e, t) c =
+  (* 引数の数が同じ *)
+  fprintf ppf
+          "%d 番目の引数で型が合いません。@ \
+           %d 番目の引数、%d 番目の引数に要求される型、コンストラクタの定義は以下の通りです。@]@."
+          n n n;
+  fprintf ppf
+          " @[<2>%d 番目の引数 %a：@,%a@]@."
+          n Pprintast.expression e Printtyp.type_expr t;
+  fprintf ppf
+          " @[<2>%d 番目の引数に要求される型：@,%a@.@]"
+          n Pprintast.core_type c;
+and print_constuctor_type lid cts =
+      fprintf ppf
+      " @[コンストラクタの定義：@,%s " (string_of_longident lid);
+     let rec print_core ct = match ct with
+         [] -> ()
+       | [first] ->
+          (* 引数が一つしかない場合 *)
+          fprintf ppf "%a" Pprintast.core_type first
+       | first :: rest ->
+          fprintf ppf "%a * " Pprintast.core_type first;
+          print_core rest in
+     if cts <> []
+     then (fprintf ppf "of ";  print_core cts);
+     fprintf ppf "@]@."
+
+and print_arity_mismatch n m =
+  (* 引数の数が異なる *)
+  fprintf ppf
+          "引数の数が違います。@ \
+           ハイライトされた部分では %d 個になっていますが、定義では %d 個です。@]@." n m
+and print_no_args l =
+  (* 引数が見つからない *)
+  fprintf ppf
+          "引数が見つかりません。@ \
+           （もしくは、 (%s ...) のようにかっこをつけましょう。）@]@." l
+
+let print_illtyped_constructor lid plst args =
+  match language with
+| English -> fprintf ppf
+    "@[Error25 : The constructor is given a wrong type of argument(s).@]@."
+| Japanese ->
+   fprintf ppf
+    "@[Error25 : コンストラクタの引数の型が合っていません。@]@.";
+   print_type lid plst args
+
+let print_illtyped_other () =
+  match language with
+| English -> fprintf ppf
+    "@[Error26 : This expression is ill-typed.@]@."
+| Japanese -> fprintf ppf
+    "@[Error26 : この部分に型がつきません。@]@."
+
+let print_illtyped_too_much_args n exp_typ typs name =
+  match language with
+| English ->
+    fprintf ppf
+      "@[The type conflict occurs at the %s argument.@]@."
+      (nth n)
+| Japanese ->
+    fprintf ppf
+      "@[Error27 : この関数呼び出しで渡されている引数が多いようです。@,\
+       関数と引数の型は以下の通りです。@]@.";
+    fprintf ppf
+      "@[関数部分 %a：@,%a@]@."
+      Pprintast.expression name
+      Printtyp.type_expr exp_typ;
+    print_illtyped_apply_args typs 1
+
+let print_illtyped_apply_not_function exp =
+  match language with
+| English -> fprintf ppf
+    "@[Error28 : This is not a function@]@.";
+| Japanese ->
+    fprintf ppf
+      "@[Error28 : ハイライトされた部分が関数呼び出しになっているのに、@,\
+       関数部分が@ %a@ 型になっています。@]@."
+       Printtyp.type_expr exp
+
+(* Error29 is already defined above *)
+
+let print_pattern () =
+  match language with
+| English -> fprintf ppf
+    "@[Error30 : This pattern is ill-formed.@]@."
+| Japanese -> fprintf ppf
+    "@[Error30 : ハイライトされたパターンに型がつきません@]@."
+
+let print_guard typ =
+  Printtyp.reset_and_mark_loops typ;
+  match language with
+| English -> fprintf ppf
+    "@[Error31 : The type of this expression is:@ %a,@,\
+     but it has to be bool.@]@."
+    Printtyp.type_expr typ
+| Japanese -> fprintf ppf
+    "@[Error31 : ハイライトされた部分の型は@ %a@ ですが@ \
+     bool 型でなくてはなりません。@]@."
+    Printtyp.type_expr typ
+
+let print_guard_env () =
+  match language with
+| English -> fprintf ppf
+    "@[Error32 : A variable in this expression is used at different type@ \
+     at different place.@]@."
+| Japanese -> fprintf ppf
+    "@[Error32 : この式の中の変数が、別のところで別の型で使われています。@]@."
+
+(* Error33 is already defined above *)
+
+let print_illtyped_record typ fields =
+  (* 式が □ でないフィールドの情報だけを取る *)
+  List.iter (
+    fun ((f, ft), (e, et)) ->
+      if e.pexp_desc <> Debug_core.skeleton'.pexp_desc then
+        begin
+          fprintf ppf
+                  "@[Error34 : レコード %a のフィールド %s の型が合っていません。@ \
+                   ハイライト部分、定義上の型は以下の通りです。@]@."
+                  type_expr typ (Longident.last f);
+          fprintf ppf
+                  "@[ハイライト部分：@,(%a : %a)@]@."
+                  Pprintast.expression e type_expr et;
+          fprintf ppf
+                  "    @[定義上の型：@,%a@.@]"
+                  Pprintast.core_type ft.pld_type
+        end
+    ) fields
+
+let print_label_mul fname =
+  match language with
+| English -> fprintf ppf
+    "@[Error35 : The record field label %s@ is defined several times.@]@." fname
+| Japanese -> fprintf ppf
+    "@[Error35 : ハイライトされた部分で、レコードのフィールド %s が複数回使われています。@ \
+     (レコードのフィールド名はすべて異なる必要があります。)@]@." fname
+
+let print_illtyped_constraint typ1 typ2 =
+  Format.fprintf ppf
+    "@[Error36 : ハイライトされた部分で、: の左側の式は %a 型ですが、@ \
+     : の右側の型は %a 型です。これらは同じ型でなくてはなりません。@]@."
+    Printtyp.type_expr typ1 Printtyp.type_expr typ2;
+  check_duplicate typ1 typ2
+
+let print_no_method_use () =
+  Format.fprintf ppf
+    "@[Error37 : #use はファイルの先頭に書きましょう。@]@."
+
+let print_illtyped_array typ1 typ2 =
+  Format.fprintf ppf
+                 "@[Error38 : ハイライトされた部分は %a 型の配列ですが、@ \
+                  %a 型の要素が含まれています。 @ \
+                  配列の各要素の型は、すべて同じである必要があります。@]@."
+                 Printtyp.type_expr typ1 Printtyp.type_expr typ2;
+  check_duplicate typ1 typ2
+
+let print_orpad_vars () =
+  fprintf ppf
+          "@[Error39 : 変数を含むパターンは、| で矢印の左側にまとめることができません。@,\
+           すべてのパターンに式をつけるか、パターンに変数を含まないようにしましょう。@]@."
+
+let print_multiply_bound_variable s =
+  fprintf ppf
+          "@[Error40 : ハイライトされた部分で、パターン変数 %s が多重に定義されています。@,\
+           (ひとつのパターンの中に定義する変数の名前はすべて異なる必要があります。)@]@." s
+
+(* let文のエラー *)
+let print_illtyped_let_rec1 v =
+  fprintf ppf
+          "@[Error41 : ハイライト部分の関数定義 %a に再帰があります。@,\
+           let の後に rec を書きましょう。@]@."
+          Pprintast.pattern v.pvb_pat
+
+let print_illtyped_let_rec_many vs =
+  fprintf ppf
+          "@[Error42 : ハイライト部分の関数定義 ";
+  List.iter (fun v' -> fprintf ppf "%a " Pprintast.pattern v'.pvb_pat) vs;
+  fprintf ppf "@,\
+           に相互再帰があります。let の後に rec を書きましょう。@]@."
+
+let print_illtyped_let v vs =
+  fprintf ppf
+          "@[Error43 : ハイライト部分の関数定義 %a の中で、@,\
+           and で同時に定義された他の関数 "
+          Pprintast.pattern v.pvb_pat;
+  List.iter (fun v' -> fprintf ppf "%a " Pprintast.pattern v'.pvb_pat) vs;
+  fprintf ppf
+          "@,\
+           が1つ以上呼び出されています。in や ;; を使って各定義を独立させましょう。@]@."
+
+let print_illtyped_case exp =
+  fprintf ppf
+          "@[Error44 : ハイライト部分のパターン変数 %a が @,\
+           式中で異なる型として使われています。@]@." Pprintast.expression exp
+
+let print_label_mismatch env lid trace =
+  match language with
+| English -> report_unification_error ppf env trace
+        (function ppf ->
+           fprintf ppf "@[Error51 : The record field %a@ belongs to the type"
+                   longident lid)
+        (function ppf ->
+           fprintf ppf "but is mixed here with fields of type");
+             fprintf ppf "@]@."
+| Japanese -> report_unification_error ppf env trace
+        (function ppf ->
+           fprintf ppf "@[Error51 : フィールド %a@ が属する型は"
+                   longident lid)
+        (function ppf ->
+           fprintf ppf "ですが、それを含む全体のレコード型は");
+              fprintf ppf " です。@]@."
+
+let print_label_missing labels =
+  match language with
+| English ->
+   let print_labels ppf =
+     List.iter (fun lbl -> fprintf ppf "@ %s" (Ident.name lbl)) in
+   fprintf ppf "@[<hov>Some record fields are undefined:%a@]"
+           print_labels labels
+| Japanese ->
+   let print_labels ppf =
+     List.iter (fun lbl -> fprintf ppf " %s" (Ident.name lbl)) in
+   fprintf ppf "@[Error52 : ハイライトされた部分で、レコードのフィールド%a が足りません。@]@." print_labels labels
+
+let print_illtyped_try_right typ1 typ2 =
+  begin match language with
+| English -> fprintf ppf
+    "@[Error53 : Somewhere in this try expression is wrong.@]@." (* 英語 *)
+| Japanese -> fprintf ppf
+    "@[Error53 : try する式が@ %a@ 型で矢印の右側が@ %a@ 型になっていますが、\
+     @,これらは同じ型でなくてはなりません。@]@."
+    Printtyp.type_expr typ1 Printtyp.type_expr typ2
+  end;
+  check_duplicate typ1 typ2
+
+let print_illtyped_try_left typ =
+  match language with
+| English -> fprintf ppf
+    "@[Error54 : Somewhere in this try expression is wrong.@]@." (* 英語 *)
+| Japanese -> fprintf ppf
+    "@[Error54 : try 文のパターンが @ %a@ 型になっていますが、\
+     @,これは例外でなくてはなりません。@]@."
+    Printtyp.type_expr typ
+
+let print_illtyped_try_env () =
+  match language with
+| English -> fprintf ppf
+    "@[Error55 : Some variables in this expression is used at different type@ \
+     at different place.@]@."
+| Japanese -> fprintf ppf
+    "@[Error55 : ハイライト部分の変数が\
+     別の場所で別の型として使われています。@]@."
+
+
+let print_wrong_name kind typ name =
+  match language with
+  | English ->
+     fprintf ppf
+	     "@[Error56 : The %s %s does not belong to type %a.@]@."
+	     (if kind = Typecore.Datatype_kind.Record then "field" else "constructor") name Printtyp.type_expr typ
+  | Japanese ->
+     fprintf ppf
+	     "@[Error56 : %s %s は %a の中で定義されていません。@]@."
+	     (if kind = Typecore.Datatype_kind.Record then "フィールド" else "コンストラクタ") name Printtyp.type_expr typ
+
+let print_unbound_name kind lid =
+
+  let var_name = Longident.last lid in (* 変数名 *)
+  let mod_names = (* モジュールの名前リスト *)
+    List.filter (fun v -> v <> var_name)
+                (List.rev (Longident.flatten lid)) in
+
+  fprintf ppf
+          "@[Error57 : %s という名前の%sは、%s定義されていません。@]@."
+          var_name
+          (if kind = "record"
+           then "フィールドを持つレコード"
+           else if kind = "module"
+           then "モジュール"
+           else "コンストラクタ")
+          (if mod_names = [] then ""
+           else "モジュール" ^ List.hd mod_names ^ "の中で")
+
+let print_duplicate_name kind name =
+  match language with
+  | English ->
+     fprintf ppf "@[Two constructors are named %s@]@." name
+  | Japanese ->
+     let kind' = (if kind = "record" then "フィールド" else "コンストラクタ") in
+     fprintf ppf "@[Error58 : %s %s が複数あります。@,\
+                  定義する%sの名前は、すべて異なる必要があります。@]@." kind' name kind'
